# "uname -r" output of the kernel to build for, the running one
# if none was specified with "--define 'kernel <uname -r>'"
%{!?kernel: %{expand: %%define kernel %(uname -r)}}

%define kversion %(echo %{kernel} | sed -e s/xen// -)
%define krelver  %(echo %{kversion} | tr -s '-' '_')
%define MODULES_DIR	  /lib/modules
%define KVERSION %{kernel}

%if %(echo %{kernel} | grep -c xen)
        %{expand:%%define kxensufix -xen}
%endif

%define version           7.0.0
%define release           0
%define fullver           %{version}-%{release}-root
%define	serial	 	  1

%define ETC_DIR 	  /etc
%define USR_DIR 	  /usr
%define UTILS_DIR 	  /usr/sbin
%define PROD_HOME  	  /etc/wanpipe
%define WANCFG_LIBS_DIR   /etc/wanpipe/wancfg/lib
%define API_DIR           /etc/wanpipe/api
%define DOCS_DIR	  /usr/share/doc/wanpipe
%define PROD		  wanrouter
%define META_CONF         %{PROD_HOME}/%{PROD}.rc
%define WAN_INTR_DIR      %{PROD_HOME}/interfaces
%define WAN_CONF_DIR      %{PROD_HOME}
%define PROD_CONF         %{WAN_CONF_DIR}/wanpipe1.conf
%define LIBSANGOMA_CONF   /etc/ld.so.conf.d/libsangoma.so.conf
#%define START_SCRIPT      S07%{PROD}
#%define OLD_START         S07router
#%define STOP_SCRIPT       K10%{PROD}
#%define OLD_STOP          K10router
%define ROUTER_RC         %{META_CONF}
%define WANROUTER_STARTUP_SMPL    %{PROD_HOME}/samples/wanrouter
%define WANROUTER_STARTUP         /usr/sbin/wanrouter
%define NEW_IF_TYPE               NO
%define PROD_INIT                 /usr/sbin/

%define dahdiver 2.6.1

Name:       wanpipe-util
Summary: 	Sangoma WANPIPE package for Linux. It contains WANPIPE configuration/startup/debugging utilities for Linux. This package requires the wanpipe-mod package!
Group: 		Applications/Communications
Group:		Networking/WAN
Version: 	%{version}
Release: 	%{release}
License: 	GPL plus freely redistributable binaries
Vendor:		Sangoma Technologies Inc.
Url:		www.sangoma.com
BuildRoot: %{_tmppath}/wanpipe-%{version}-%{release}-root


%if 0%{?fedora}%{?centos_ver}
Requires(pre): coreutils, chkconfig, syslog
BuildRequires: kernel%{?kxensufix}-devel-uname-r = %{kversion}
%else
Prereq: coreutils, chkconfig, syslog
BuildRequires: kernel%{?kxensufix}-devel = %{kversion}
%endif
Requires: perl
Requires: dahdi >= %{dahdiver}
BuildRequires: dahdi-devel >= %{dahdiver}, libtermcap-devel, libtool, ncurses-devel, libstdc++-devel, gcc-c++, asterisk-devel >= 1.6
BuildRequires: lksctp-tools-devel
Source0:    ftp://ftp.sangoma.com/linux/custom/3.5/wanpipe-%{version}.tgz
#Source0:    ftp://ftp.sangoma.com/linux/current_wanpipe/wanpipe-%{version}.tgz
Patch1:     wanpipe-3.5.27-fix-Makefiles.patch
Patch3:     wanpipe-7.0.0-wancfg-add-param.patch
Patch4:     wanpipe-7.0.0-wancfg-unload-arbitrary-dahdi-user.patch
Patch5:     wanpipe-3.5.27-check-modules-in-kernel-extra.patch
Patch6:		wanpipe-3.5.27-wancfg-allow-silent-gsm-codec.patch

%description -n wanpipe-util
Linux Utilities for Sangoma AFT-Series of cards and S-Series of Cards. Wanpipe 
supports the following protocols, TDM Voice, Frame Relay, X25(API), 
PPP,Multi-link PPP, CHDLC and custom API development for WAN and Voice.

Install Wanpipe-modules package for wanpipe drivers.



%package -n kmod-wanpipe%{?kxensufix}
Summary: 	Sangoma WANPIPE package for Linux. It contains the WANPIPE kernel drivers.  Please install wanpipe-util package for wanpipe utilties and configuration files.
Release: %{release}
Group: System Environment/Kernel
Group:		Networking/WAN
Group: 		Applications/Communications
Requires: wanpipe-util = %{version}-%{release}
%if 0%{?fedora}%{?centos_ver}
Requires(pre): /sbin/depmod
Requires(pre): module-init-tools
Requires(pre): kmod-dahdi%{?kxensufix} >= %{dahdiver}-0
%else
Prereq: /sbin/depmod
Prereq: module-init-tools
Prereq: kmod-dahdi%{?kxensufix} >= %{dahdiver}-0
%endif
Obsoletes: wanpipe-modules
Obsoletes: kernel-module-wanpipe%{?kxensufix}

%description -n kmod-wanpipe%{?kxensufix}
Linux Drivers for Sangoma AFT Series of cards and S Series of Cards. Wanpipe 
supports the following protocols, TDM Voice, Frame Relay, X25(API), 
PPP,Multi-link PPP, CHDLC and custom API development for WAN and Voice. 
Compiled for: %{kversion} (%{_target_cpu}%{?kxensufix:, XEN})

Install Wanpipe-util package for wanpipe utilities and configuration files.

%prep
%setup -n wanpipe-%{version}

# Fix wrong permission in 3.5.24 tarball
chmod u+rw util/bwm-ng/config.h.in

%patch1 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1

# Remove SVN control directories, if any exist
echo "Removing SVN control directories..."
rm -rf `find . -name .svn`

# Remove stray Module.symvers files
rm -rf `find patches/kdrivers -name Module.symvers`

# make clean in asterisk files
# Deprecated as of 3.5.20.4
#make -C ssmg/sangoma_mgd.trunk/chan_woomera.trunk/ PBXDIR=/usr PBXFLAGS_EXTRA="-DAST18" clean

# Remove all .orig files that might otherwise be installed
rm -rf `find . -name '*.orig'`

%build

# Rebuild configure for some directories
for i in `find . -name init-automake.sh` ; do
    D=`dirname $i`
    echo "Running init-automake.sh on $i ..."
    P=`pwd`
    cd $D
    ./init-automake.sh
    cd $P
done

# Configure directories
for i in `find . -name configure | grep -v wanec` ; do
    D=`dirname $i`
    echo "Running configure on $i ..."
    P=`pwd`
    cd $D
    %configure
    cd $P
done

# Copy the kernel build tree from its original location
mkdir ksrc
cp -r /lib/modules/%{kernel}/build/* ksrc/
cp /lib/modules/%{kernel}/build/.config ksrc/
for i in patches/kdrivers/include/*.h ;do 
	X=`basename $i`
	if [ -e ksrc/include/linux/$X ] ; then
		rm ksrc/include/linux/$X
	fi
done

KSRC_ABS=`pwd`
make KDIR=$KSRC_ABS/ksrc/ KVER=%{kernel} WARCH=%{_arch} INSTALLPREFIX=%{buildroot} LIBPREFIX=/usr dahdi DAHDI_DIR=/usr
make KDIR=$KSRC_ABS/ksrc/ KVER=%{kernel} WARCH=%{_arch} INSTALLPREFIX=%{buildroot} LIBPREFIX=/usr smgbri DAHDI_DIR=/usr


# Deprecated as of 3.5.20.4
#make -C ssmg/sangoma_mgd.trunk/chan_woomera.trunk/ PBXDIR=/usr PBXFLAGS_EXTRA="-DAST18 -DAST_MODULE=\\\"chan_woomera\\\""

%install
%{__rm} -rf %{buildroot}
mkdir -p %{buildroot}

make INSTALLPREFIX=%{buildroot} LIBPREFIX=/usr KVER=%{kernel} install
make INSTALLPREFIX=%{buildroot} LIBPREFIX=/usr KVER=%{kernel} install_lib
make INSTALLPREFIX=%{buildroot} LIBPREFIX=/usr KVER=%{kernel} install_smgbri

# Override PBXMODDIR since otherwise it tries to install to hardcoded /usr/lib, not %{_libdir}
# Deprecated as of 3.5.20.4
#make -C ssmg/sangoma_mgd.trunk/chan_woomera.trunk/ PBXDIR=/usr INSTALLPREFIX=%{buildroot} PBXMODDIR=%{_libdir}/asterisk/modules install
#mv %{buildroot}/etc/asterisk/woomera.conf %{buildroot}/etc/asterisk/woomera.conf.sample

# Fix incorrect destination of symlink - otherwise packaging fails
(cd %{buildroot}/usr/include/wanpipe/ && rm -f linux && ln -s . linux)

echo "PBXD=asterisk" > %{buildroot}/etc/wanpipe/pbxd

# Programs and scripts for BRI control
make INSTALLPREFIX=%{buildroot} LIBPREFIX=/usr KVER=%{kernel} install_bri

# Remove temporary files from API examples in /etc/wanpipe/api
rm -rf `find %{buildroot}/etc/wanpipe/api/ -name *.*o`
rm -rf `find %{buildroot}/etc/wanpipe/api/ -name *.la`
rm -rf `find %{buildroot}/etc/wanpipe/api/ -name *.a`
rm -rf `find %{buildroot}/etc/wanpipe/api/ -name autom4te.cache`
rm -rf `find %{buildroot}/etc/wanpipe/api/ -name .libs`
rm -rf `find %{buildroot}/etc/wanpipe/api/ -name .deps`

# Remove symbolic link that conflicts with real directory and breaks update
rm %{buildroot}/usr/include/wanpipe/oct6100_api

# Collect all kernel modules in extra for weak-updates support
mkdir %{buildroot}/lib/modules/%{kernel}/extra
mv `find %{buildroot}/lib/modules/%{kernel}/kernel/ -name *.ko` %{buildroot}/lib/modules/%{kernel}/extra
rm -rf %{buildroot}/lib/modules/%{kernel}/kernel/
ls %{buildroot}/lib/modules/%{kernel}/extra/*.ko | sed -ne 's:^%{buildroot}::p' > %{buildroot}/lib/modules/%{kernel}/extra/.kmod-wanpipe-%{version}-%{release}

%clean
%{__rm} -rf %{buildroot}

%post -n kmod-wanpipe%{?kxensufix}
#check dependancies for the new modules
depmod -ae -F /boot/System.map-%{KVERSION} %{KVERSION}
echo "Wanpipe Modules located in %{MODULES_DIR}/%{KVERSION}"   

cat /lib/modules/%{kernel}/extra/.kmod-wanpipe-%{version}-%{release} | /sbin/weak-modules --add-modules


%preun -n kmod-wanpipe%{?kxensufix}

# Run weak-module uninstall on uninstall only
if [ $1 -eq 0 ] ; then
    cp /lib/modules/%{kernel}/extra/.kmod-wanpipe-%{version}-%{release} /tmp/
fi


%postun -n kmod-wanpipe%{?kxensufix}

# Run weak-module uninstall on uninstall only
if [ $1 -eq 0 ] ; then
    cat /tmp/.kmod-wanpipe-%{version}-%{release} | /sbin/weak-modules --remove-modules
    rm -f /tmp/.kmod-wanpipe-%{version}-%{release}
fi


%preun -n wanpipe-util
if [ $1 -eq 0 ] ; then
	echo "Uninstalling WANPIPE..."
	# Remove initialization scripts.
	chkconfig --del wanrouter
	rm /etc/init.d/wanrouter
fi

#%postun -n wanpipe-util


%post -n wanpipe-util

#update ldconfig
ldconfig

# check if the /etc/wanpipe/wanrouter.rc exists, if not create it
if [ -e %{META_CONF} ]; then
	echo "Found existing Wanpipe configuration..."
else
	echo "No existing Wanpipe configuration found..."
	cp /etc/wanpipe/samples/wanrouter.rc %{META_CONF}
fi

#update syslog
if [ -e  /etc/syslog.conf ]; then
	mysyslog='syslog'
elif [ -e /etc/rsyslog.conf ] ; then
	mysyslog='rsyslog'
else
	mysyslog=" "
fi
if [  "$mysyslog" != " " ]; then
	eval "grep "local2.*sangoma_mgd" /etc/$mysyslog.conf" > /dev/null 2> /dev/null
	if [ $? -ne 0 ]; then
		eval "grep "local2" /etc/$mysyslog.conf " > /dev/null 2> /dev/null
		echo -e "\n# Sangoma Media Gateway log" > tmp.$$
		echo -e "local2.*                /var/log/sangoma_mgd.log\n" >> tmp.$$
		eval "cat /etc/$mysyslog.conf tmp.$$ > tmp1.$$"
		cp -f tmp1.$$ /etc/$mysyslog.conf
		eval "/etc/init.d/$mysyslog restart"
	fi
	eval "grep "local3.*sangoma_bri" /etc/$mysyslog.conf" > /dev/null 2> /dev/null
	if [ $? -ne 0 ]; then
		eval "grep "local3" /etc/$mysyslog.conf " > /dev/null 2> /dev/null
		echo -e "\n# Sangoma BRI Daemon (smg_bri)  log" > tmp.$$
		echo -e "local3.*                /var/log/sangoma_bri.log\n" >> tmp.$$
		eval "cat /etc/$mysyslog.conf tmp.$$ > tmp1.$$"
		cp -f tmp1.$$ /etc/$mysyslog.conf
		eval "/etc/init.d/$mysyslog restart"
	fi
fi
if [ -f tmp1.$$ ]; then
	rm -f  tmp1.$$
fi
if [ -f tmp.$$ ]; then
	rm -f  tmp.$$
fi

# install start scripts
rm -f /etc/init.d/wanrouter
ln -s /usr/sbin/wanrouter /etc/init.d/wanrouter
chkconfig --add wanrouter

# we're done...print a happy message
cat <<EOM
*** Sangoma Wanpipe was successfully installed.
    Hardware Probe: /usr/sbin/wanrouter hwprobe
    Wanpipe Config: /usr/sbin/wancfg_fs
    Wanpipe Start : /usr/sbin/wanrouter start

EOM


%files -n kmod-wanpipe%{?kxensufix}
/lib/modules/%{kernel}/extra/*.ko
/lib/modules/%{kernel}/extra/.kmod-wanpipe-%{version}-%{release}

%files -n wanpipe-util
%config(noreplace) %{_sysconfdir}/wanpipe/wanrouter.rc
%{_sysconfdir}/wanpipe/*
%config(noreplace) %{_sysconfdir}/sangoma_mgd.conf
/usr/local/*
%{_sbindir}/*
%{_libdir}/libsangoma.*
%{_libdir}/libstelephony.*
%{_libdir}/libteletone.*
/usr/include/*.h
/usr/include/wanpipe/*

%changelog
* Mon Feb 25 2013 Alex Villacis Lasso <a_villacis@palosanto.com> 7.0.0-0
- Update to 7.0.0
- Explicitly remove *.orig to prevent installing unnecessary files.
- Attempt to handle CentOS 6 via the centos_ver macro just like a Fedora. 

* Tue Aug 14 2012 Alex Villacis Lasso <a_villacis@palosanto.com> 3.5.28-0
- Update to 3.5.28

* Wed May 30 2012 Alex Villacis Lasso <a_villacis@palosanto.com> 3.5.27-0
- Update to 3.5.27
- Recompile for DAHDI 2.6.1
- Fix silent configuring when configuring a GSM card.

* Tue Mar 06 2012 Alex Villacis Lasso <a_villacis@palosanto.com> 3.5.25-0
- Update to 3.5.25
- Add missing Requires: wanpipe-util for kmod-wanpipe

* Sat Jan 07 2012 Alex Villacis Lasso <a_villacis@palosanto.com> 3.5.24-0
- Update to 3.5.24

* Wed Dec 07 2011 Alex Villacis Lasso <a_villacis@palosanto.com> 3.5.23-2
- Include support for kernel module weak updates.
- Fix wanrouter script to check first in extra kernel directory.

* Mon Sep 26 2011 Alex Villacis Lasso <a_villacis@palosanto.com> 3.5.23-1
- Fix incorrect inclusion of debug symbols in /usr/lib/debug in 32-bit package.
- Move include files from kernel-module-wanpipe to wanpipe-util. 

* Wed Sep 14 2011 Alex Villacis Lasso <a_villacis@palosanto.com> 3.5.23-0
- Update to 3.5.23

* Thu Sep  8 2011 Alex Villacis Lasso <a_villacis@palosanto.com> 3.5.22.4-0
- Update to 3.5.22.4

* Mon Aug 29 2011 Alex Villacis Lasso <a_villacis@palosanto.com> 3.5.22.3-0
- Update to 3.5.22.3
- Patch wancfg_zaptel.pl to unload any arbitrary module that uses dahdi
  directly or indirectly, instead of hardcoding the known module list. This
  prevents additional drivers from keeping dahdi in use after configuring
  a Sangoma card alongside a third-party telephony card.

* Mon Aug 15 2011 Alex Villacis Lasso <a_villacis@palosanto.com> 3.5.20-2
- Rebuild to cope with ABI change from dahdi-2.4.1.2-4

* Tue May 10 2011 Alex Villacis Lasso <a_villacis@palosanto.com> 3.5.20-1
- Add Prereq for sysklogd
- Fix shell comparison in postinstall script
- Prevent preuninstall script from removing /etc/init.d/wanrouter on update.

* Thu Apr 28 2011  Alex Villacis Lasso <a_villacis@palosanto.com> 3.5.20-0
- Update to 3.5.20
- Recompile for dahdi-2.4.1.2, asterisk 1.8.3.3

* Mon Jan 03 2011 Alex Villacis Lasso <a_villacis@palosanto.com> 3.5.18-1
- Due to changes in makefiles, all_src no longer compiles dahdi support. Use
  all_src_dahdi instead.

* Mon Dec 27 2010 Alex Villacis Lasso <a_villacis@palosanto.com> 3.5.18-0
- Update to 3.5.18

* Wed Oct 27 2010 Alex Villacis Lasso <a_villacis@palosanto.com> 3.5.17-0
- Update to 3.5.17
- Recompile for dahdi-2.4.0

* Wed Jun 30 2010 Alex Villacis Lasso <a_villacis@palosanto.com> 3.5.14-0
- Update to 3.5.14

* Thu May 27 2010 Alex Villacis Lasso <a_villacis@palosanto.com> 3.5.11.6-0
- Update to 3.5.11.6 to fix WARN_ON with dahdi-2.3.0 .

* Tue May 18 2010 Alex Villacis Lasso <a_villacis@palosanto.com> 3.5.11-0
- Update to 3.5.11

* Mon Mar 01 2010 Alex Villacis Lasso <a_villacis@palosanto.com> 3.5.10-0
- Update to 3.5.10

* Wed Dec 09 2009 Alex Villacis Lasso <a_villacis@palosanto.com> 3.5.8-0
- Update to 3.5.8
- Fix hardcoded path to Asterisk module directory which breaks woomera config in 64-bits.

* Wed Oct 21 2009 Alex Villacis Lasso <a_villacis@palosanto.com> 3.5.7-3
- wancfg_zaptel.pl: Reorder parameter evaluation so it actually works.

* Tue Oct 13 2009 Alex Villacis Lasso <a_villacis@palosanto.com> 3.5.7-2
- Remove bogus Module.symvers files that import incorrect dahdi symbol versions

* Thu Oct 08 2009  Alex Villacis Lasso <a_villacis@palosanto.com> 3.5.7-1
- Update to 3.5.7
- Indicate asterisk-devel >= 1.6.x in BuildRequires

* Fri Sep 25 2009 Alex Villacis Lasso <a_villacis@palosanto.com> 3.5.4.17-1
- Bump version for build against asterisk-1.6.x

* Thu Jul 23 2009 Alex Villacis Lasso <a_villacis@palosanto.com> 3.5.4.17-0
- Update to 3.5.4.17
- Rebuild against dahdi-2.2.0.1
- Drop module refcounting patch, as proper refcounting seems to be put in place.
- Remove svn directories before build to avoid packing them in binary RPM.
- woomera: decline load instead of failing on failure to load config.
- woomera: Disable debugging option on configuration.

* Mon Jul 20 2009 Alex Villacis Lasso <a_villacis@palosanto.com> 3.4.1-5
- Patch chan_woomera to report failure to connect to socket just once.
- Install sangoma_brid which is a binary without source.
- Update license tag to reflect the fact that some binaries have no source.

* Fri Jul 03 2009 Alex Villacis Lasso <a_villacis@palosanto.com> 3.4.1-4
- Add kernel module refcounting on channel open and close. Should fix 
  kernel panic from bug #126.
- Do not remove /etc/init.d/wanrouter on upgrade, just on uninstall.

* Thu Jul 02 2009 Alex Villacis Lasso <a_villacis@palosanto.com> 3.4.1-3
- Revert building with Module.symvers from dahdi. This does not solve the
  kernel crash on unload at all, and introduces symbol verification mismatches.
- Reinstate copying of kernel headers to temporary location during build.

* Thu Jun 11 2009 Alex Villacis Lasso <a_villacis@palosanto.com> 3.4.1-2
- Enable build of libteletone
- Add lksctp-tools-devel to BuildRequires
- Fix Makefile for sangoma_smg, and enable build
- Enable build of chan_woomera
- Do not replace configuration files on update
- Rebuild with Module.symvers from dahdi

* Tue May  5 2009 Alex Villacis Lasso <a_villacis@palosanto.com> 3.4.1-1
- Add libtermcap-devel, libtool, ncurses-devel, libstdc++-devel, gcc-c++ to BuildRequires.

* Mon May  4 2009 Alex Villacis Lasso <a_villacis@palosanto.com> 3.4.1-0
- Update to 3.4.1
- Patch removed (wanpipe-fix-kernel-panic-on-rmmod.patch) as fix was merged upstream.
- Found one more instance of install outside buildroot, fixed.

* Fri Apr 24 2009 Alex Villacis Lasso <a_villacis@palosanto.com> 3.3.16-0
- Update to 3.3.16.
- Following explanation from Nenad Corbic, the rpmspec dumps use of the Setup
  script. Instead, the top-level Makefile is fixed to be capable to override
  the kernel include, giving the private includes a greater priority. This
  makes the kernel-include-tree-copy hack unnecessary, and is therefore dropped.
  Also, some scripts are fixed to not try to overwrite the kernel include files,
  since this is now unnecessary.
- Installation prefix is now properly settable.
- builddir path removal from wanrouter.rc is now unnecessary
- Comments in rpmspec translated into English.
- Properly patch /etc/wanpipe/wancfg_zaptel.pl here rather than in the elastix RPM.

* Mon Apr 20 2009 Alex Villacis Lasso <a_villacis@palosanto.com> 3.3.15-4
- At long last, I fixed a kernel panic crash on "rmmod wanpipe" or system
  shutdown/reboot, with patch wanpipe-fix-kernel-panic-on-rmmod.patch . 
  Will try to push patch upstream. Should fix one issue reported in #76.

* Fri Apr 17 2009  Alex Villacis Lasso <a_villacis@palosanto.com> 3.3.15-3
- Add forgotten Obsoletes directive for kernel modules. Should fix Elastix 
  bug #73 .

* Thu Mar 26 2009 Alex Villacis Lasso <a_villacis@palosanto.com> 3.3.15-2
- Fix replacing of buildroot to be more robust when changing versions. Fixes
  http://bugs.elastix.org/view.php?id=45

* Mon Mar 09 2009 Alex Villacis Lasso <a_villacis@palosanto.com> 3.3.15-1
- Fix dependency on kernel-module-dahdi-devel (remove xen)

* Mon Feb 24 2009 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.16
=====================================================================

- Fixed S514 2 Byte receive

- A14X Serial Driver Update
  Added clock recovery option
  Added control of DTR/RTS on startup using 
  DTR_CTRL and RTS_CTRL config variables.

- AFT T1/E1 BIRT Feature
  Ability to run Birt tests on T1/E1 cards using wanpipemon

- AFT HWEC
  Hardware DTMF detection now detects FAX tones as well,
  and passes then up to Zaptel/Asterisk

- PPP Protocol
  Added option to disable MAGIC number in negotiation
  Set MAGIC_DISABLE=YES in ppp profile section.

- Updates for new 2.6.X kernels
  Added queue check on shutdown
  Support for latest 2.6 kernels

- Updated T3/E3 Code
  The T3/E3 dma logic had a bug that was demonstrated under
  high load. Was introduced in 3.3.15 release.

- Added hardware probe DUMP 
  wanrouter hwprobe dump
  To be used by developers to easily parse the hwprobe output

- ADSL Update
  Bug fix in adsl. Could cause period disconnects on
  some equipment. The SNR value was not being properly reported
  the the upstream.

* Thu Feb 05 2009 Alex Villacís Lasso <a_villacis@palosanto.com>
- Rebuild for 64 bits
- Fix many quirks for packaging a reliable source RPM for wanpipe

* Tue Dec 08 2008 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.15
=====================================================================

- Added support for new B600 Analog Card

- Added task stop function on shutdown.
  This feature prevents an unlikey event that task gets
  scheduled after card has shutdown.

- Fixed tty driver for new Linux Kernel 2.6.26 and greater

- Fixed tristate mode using wanpipemon
  Used to enable/disable T1/E1 transmitter.
  wanpipemon -p aft for help.

- Fixed yellow alarm handler on T1/E1

- Added an option to run Zaptel & TDM API on same span.

- Fixed E3 Support for A301 cards.
  A301 cards need new Firmware v11 and CPLD v0.
  wanrouter hwprobe verbose shows current firmware and cpld version.
  
- Fixed Serial AFT card events
  Added X21 Support

- Added XMTP2 API for old PMC T1/E1 cards.

- Fixed Channel Bank ring problem on AFT T1/E1 cards.
  Some channel banks would ring all phones on card stop.
  This is now fixed.

- Updated AFT Core to fix XMTP2 startup with 16E1 links.

- Updated API for A14X Serial Cards
  Ability to recevie Modem Events.

- Updated for Serial A14X API
  API for setting and receiving line events
  Sample code wanpipe-<version>/api/aft/aft_api_serial.c

- Updated Serial A14X for NRZI
  New firware update v05

- Added wanrouter hwprobe dump
  Should be used for programs to parse hwprobe easilty


* Tue Oct 8 2008 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.14
=====================================================================

- Updated TDM API 
  This update helps FreeSwitch analog support.

- Analog TDM API TAPPING Feature
  Sangoma Analog cards and TDM API used in TAPPING mode can be used to build
  custom call recording applications

- Enabled Zaptel/DAHDI operation mode 
  This driver supports DAHDI/Asterisk
  Dahdi is supported on Asterisk 1.6 and 1.4
  Added dahdi to installation modes.
	-> ./Setup install 	#General installation
	-> ./Setup zaptel	#Zaptel based installation
	-> ./Setup dahdi	#Dahdi based installation
	-> ./Setup bri		#SMG BRI installation

- LibSS7 MTP2 Option
  The MTP2 option improves the performance of LibSS7
  eg: instead of using: dchan=24 use mtp2=24
  Please consult libss7 documentation.

- Updated TDM API for A200
  Fixes FreeSwitch OpenZAP with TDM API for Analog

- Bug fix in XMTP2 API
  The fifo error could cause xmtp2 buffering to fail

- wanpipemon utility
  Updated T1/E1 Loopback commands
  Bug fix on 2.6.25 kernels

- Driver compile update for Latest
  2.6.26 kernels

- Update AFT driver to implement new loopback commands

- Updated for 56K driver

- Added Asterisk DAHDI Support

- A200/A400 Analog driver update
  Bug fix possible race condition due to front end interrupt.

- AFT Core Update
  Disabled fifo overrun handling in transparent mode.
  It does not provide any improvement.
  XMTP2 API mode could run out of buffers due to overrun errors.
  This has now been fixed.

- Fixed A301 E3 Support
  New firmware V11 is needed.
  Please upgrade firmware before starting up the card.
  To check firmware run: wanrouter hwprobe
  

* Fri Sep 1 2008 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.13
=====================================================================

- This release was never released.



* Fri Aug 1 2008 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.12
=====================================================================

- Compilation fix for 2.6.25 kernel
  Introduced in 3.3.11 release

- Setup update
  Added bri and zaptel installation modes.
	-> ./Setup install 	#General installation
	-> ./Setup zaptel	#Zaptel based installation
	-> ./Setup bri		#SMG BRI installation

  Streamlined Setup installation script
  Added check for Asterisk directory when installing BRI
  Added check for x86 in architecture

- Fixed Makefile build

- Updated README File
  

* Wed Jul 30 2008 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.11
=====================================================================

- BRI to Analog Faxing Update
  Improved faxing over SMG Gateway and Zaptel Analog.
  This feature drastically improves faxing performance between
  BRI and Analog cards over Asterisk.

- BRI Update
  Added overlap dialing support
  Added support for BRI with 16 channel Echo Canceler.
  Support for test start option, that only verifies configuration 
  files without applying changes.
  Support for non-syslog logging.

- BRI Bug Fix
  BRI was configured for answer on accept.  This caused a call to
  be answered before the remote leg of the call became connected.
 
- T1/E1 Loopback Update
  wanpipemon was update to check loopback status as well as set
  T1/E1 loopback commands.

- Removed S508 ISA Support from drivers

- Fixed the BRI chip security handler. Tested that all BRI 
  ports get properly shut down. 

- Updated for New PLX & Tundra PCIe Bridges chips
- Update hwprobe verbose for PMC Shark

- Updated for 2.6.25 kernel

- Fixed 64bit compilation for Octasic EC Image

- TDM API Bug Fix: 
  Added a check for buffer overflow in write function.

- New Octasic EC Image
  Improves faxing over Hardware Echo Canceler. 

- BRI Bug fix on startup
  The clock measuring function has limited and could fail on some machines.

- AFT T1/E1 - Added missing LBO configuration option WAN_T1_0_110

- Updated for 2.6.25 kernel

- Updated wancfg for interface MTU/MRU
  By default do not configure interface MTU/MRU if values have
  not changed by default.  This way the global mtu can be used
  to easily configure the MTU/MRU of all interfaces.

- Updated wancfg_smg to configure XMTP2 API

- Wireshark Tracing for MTP2
  http://wiki.sangoma.com/wanpipe-wireshark-pcap-pri-bri-wan-t1-e1-tracing

- T3/E3 Update
  Driver level update to improve code.

- MTP2 API Support
  http://wiki.sangoma.com/wanpipe-aft-ss7-mtp2-api


* Fri May 15 2008 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.10
======================================================================

- BRI Update
  Binary segfaulted on some systems due to gcc incompabilitly.
  This is now fixed.

* Fri Apr 30 2008 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.9
======================================================================

- AFT BRI Clock Reference Update
  Disabled reference clocking feature on original A500 BRI Cards.
  It has been determined that reference clocking feature is not always stable 
  on original A500 BRI cards.  It can cause noise and call drops in some 
  circumstances where BRI lines go up and down due to power saving mode.
  
  If you have problems with FAX synchronization on an original A500 BRI Card
  contact Sangoma Support and we will swap out the card for one with
  an updated CPLD that will work with the reference clock and provide
  reliable FAXing.

  Run wanrouter hwprobe verbose to determine your A500 BRI CPLD Version
   -> wanrouter hwprobe verbose
	-C00 -> old bri cpld (non reference clock)
	-C01 -> new bri cpld (reference clock enabled)


- Manually Disabling BRI Clock Reference
  This option is valid from 3.3.6 release and greater.
  This option can be used in case of noise and voice quality issues
  and call drop issues on BRI card.  

  In order to disable BRI clock reference manually one can add
  RM_BRI_CLOCK=OSC in each BRI wanpipe config file in /etc/wanpipe directory.
  1. vi /etc/wanpipe/wanpipe1.conf
  2. Under the TDMV_SPAN option add
     RM_BRI_CLOCK=OSC
  3. Save file
  4. Repeat for all BRI wanpipe configuration files
  5. Restart all wanpipe devices
  
  Note from 3.3.9 release on, all old CPLD A500 BRI cards
  have clock referencing disabled automatically.

- Updated BRI Stack
  Fix for RDNIS not cleared
  Support for show_spans and show_calls.
  Added support for multiple MSNs.
  Added support for timer_t3 and timer_t302
  http://wiki.sangoma.com/sangoma-wanpipe-smg-asterisk-bri-installation
  

* Fri Apr 25 2008 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.8
======================================================================

- AFT Update
  A bug was introduced in 3.3.7 release that failed to load
  AFT cards without HWEC.  

- AFT TE1 Code
  Defaulted Maxim T1 Rx Level to 36DB
  Defaulted Maxim E1 Rx Level to 42DB
  This will improve T1/E1 connectivity on noisy or low power lines.

- AFT BRI Update
  Minor update on BRI to conform better to TBR3 Certification 


* Wed Apr 23 2008 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.7
======================================================================

- BRI HWEC MAJOR Bug Fix
  BRI hwec was not configured properly on startup.
  Every second channel on each span was not being configured for hwec.
  This would result in random echo problems.

- Support for 2.6.24 kernels and up
  This release will now compile properly on 2.6.24 kernels and up.

- AFT Analog Update
  Added TBR21 operation mode
  Used for most european countries.
  -> this option must be added manually in wanpipe#.conf
  -> TDMV_OPERMODE=TBR21

- AFT A144 Update
  Added MPAPI X25 support to AFT A144/A142 cards
  Use: wancfg_legacy to configure MPAPI over AFT cards.
  http://wiki.sangoma.com/wanpipe-linux-mpapi-x25

- BRI Updated
  BRI driver updated for new 512hz clock used to improve
  hardware echo canceler with clock recovery mechanism.
  This featue will solve any random hwec warning messages
  one might see in /var/log/messages.  Note these random
  warning messages did not cause any abnormal behaviour 
  in extensive lab testings.   
  To check your BRI hardware version run:	
  -> wanrouter hwprobe verbose
	-C00 -> old bri cpld
	-C01 -> new bri cpld

- Wanpipemon PRI/BRI PCAP Tracing for Wireshark
  Using wanpipemon dchan trace one can now capture
  pcap files that can be opened by Wireshark.
  http://wiki.sangoma.com/wanpipe-wireshark-pcap-pri-bri-wan-t1-e1-tracing

- S514 Secondary port bug fix
  The secondary port was not working.

- Updated wanrouter hwprobe
  New wanrouter hwprobe device summary line will only contain
  found devices. For backward compatibility we created "wanrouter hwprobe legacy"
  that can be used to revert hwprobe output to the original format.

- Add pci parity check to wanrouter 
  wanrouter parity  	-> displays current system pci parity
  wanrouter parity off 	-> disables system pci parity
  wanrouter parity on	-> enables system pci parity
  
  /etc/wanpipe/wanrouter.rc  
	WAN_PCI_PARITY=OFF -> on wanrouter start disable pci parity
			   -> event logged in /var/log/wanrouter

  On some servers pci parity can cause NMI interrupts that
  can lead to reboots.  Parity can be caused by unsuported
  or buggy pci/bridge chipsets.  The above commands can be used
  to combat pci parity reboots.

  Another option is to disable PCI parity in BIOS :)


* Wed Apr 4 2008 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.6
======================================================================

- BRI Driver bug fixes
  Secured the bri restart logic to prevent possible
  race conditions.

- BRI Stack update
  Bug Fix: bri stack update fixes reconnect on etsi lines
  Feature: group outbound calls skip disconnected lines

- T3 update
  Fixed dma issues on some machines when tx/rx mixed
  voip and data traffic.

- Hardware Probe Verbose Update
  Analog and BRI cards now display PCI/PCIe info on
  wanrouter hwrobe verbose.


* Wed Mar 27 2008 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.5
======================================================================


- Removed debugging out of firmware update utility
- Updated firmware bin files
- Updated firmware update script.

- No Functional Changes from 3.3.4

* Wed Mar 26 2008 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.4
====================================================================== 

- BRI TE auto clocking feature - Bug fix
   This feature failed on on some machines with multiple TE BRI modules.
   This bug would cause modules to loose sync. Bug introduced in 3.3.3
   release.

* Tue Mar 25 2008 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.3
====================================================================== 

-  BRI TE auto clocking feature. 
    Where a connected TE port is elected
    as the telco clock recovery port for the whole card.  If that TE
    port goes down, another connected TE port is found to provide
    telco recovery clock to the card.  If no connected TE ports are found
    then internal oscillator is used. 
    -> This option is fully automatic no configuration options needed.

-  BRI Zaptel Clock Source
    Since BRI does not interface to zaptel, it acts as ZT DUMMY to
    provide zaptel reliable timing.  One has to configure
    TDMV_DUMMY_REF=YES in [wanpipe1] section of wanpipe1.conf

-  A200/A400 Remora Relax CFG
    If one module fails during operation the wanpipe driver by default
    fails to load.  With this option wanpipe driver
    will allow the card to come up with a broken module so that
    customer will be able to continue working until the module is replaced.
    RM_RELAX_CFG=YES in [wanpipe1] section of wanpipe1.conf



* Fri Feb 14 2008 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.2.1
====================================================================== 

- Added DTR API for Serial S514X Card
  Ability to read and set the DTR/RTS on serial cards throught the API.
  Sample code in wanpipe-3.3.2.1/api/chdlc/chdlc_modem_cmd.c


* Wed Feb 12 2008 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.2
====================================================================== 

- Support for A500 hardware support with NetBricks BRI Stack
- Major A500 driver updates and fixes
- Serial A142/A144 hardware support
- AFT A056 56K hardware support 

- Support for HW DTMF

- Updates for AFT PMC and MAXIM framers
  PMC - lowered LOS sensitivity
        Fixes fake up/down state changes on
        started inactive lines.

  MAXIM - lowered sensistivy
          Fixes cable cross talk on 8 port cards.
        - Enabled Unframed E1
        - Enabled Tri-State Mode
        - Fixed loopback commands

- Updated loopback commands for AFT Maxim cards

- Updated for AstLinux
  The make file can now build all WAN and Voice Protocols
  
- Updated legacy protocols for new front end architecture

- 


* Fri Feb 01 2008 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.2.p8
====================================================================== 

- wancfg_zaptel now asks for the default_tei value for 
- BRI cards in TE mode

- Fix for HWEC not being enabled when non-consecutive modules are using 
- in BRI cards

* Fri Feb 01 2008 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.2.p4
====================================================================== 

- Fixed AFT memory leak
  Memory leak introduced in 3.3 release
- Fixed AFT 56K bug
  Bug introduced in 3.3 releae


* Fri Feb 01 2008 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.2.p3
====================================================================== 

- Fix bug in BRI protocol for fast local hangups.

* Mon Jan 18 2008 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.2.p1
====================================================================== 

- Bug fix in Hardware EC code for E1.
  Bug introduced in 3.3 release.


* Mon Jan 18 2008 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.1
==================================================================== 


* Mon Jan 16 2008 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.0.22
==================================================================== 

- BRI protocol:Increased internal timer that could cause issue in systems with
- more than 8 BRI spans

* Mon Jan 15 2008 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.0.21
==================================================================== 

- BRI protocol:Fix for smg_brid daemon crashing on race condition
- BRI protocol:default_tei parameter is not ignored when using point to 
- multipoint anymore

* Mon Jan 14 2008 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.0.20
====================================================================  

- BRI protocol: Additional prefix options. 
- BRI protocol: Check is caller ID number is all digits on incoming calls
- Sangoma MGD: Removed dynamic user period causing skb panics
- chan_woomera: Fixed issue with rxgain and txgain values set to 0 if 
- coding not set in woomera.conf
- wancfg_zaptel: Support for fractional T1/E1 spans.
- wancfg_zaptel: fix issue BRI always being configured as bri_net introduced in v3.3.0.19

* Mon Jan 07 2008 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.0.19
====================================================================  

- Support for national/international prefix in BRI stack

* Mon Jan 07 2008 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.0.18
====================================================================  

- Changed Makefile in wanpipe/api/fr causing compilation errors 


* Thu Dec 20 2007 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.0.17
====================================================================  

- Fix for smg_ctrl boot script starting before network services on some systems
- Support for language parameter in chan_woomera

* Thu Dec 20 2007 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.0.16
====================================================================  

- Fix for Sangoma BRI Daemon crashing on incoming call if chan_woomera is not installed on that system

* Tue Dec 18 2007 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.0.15
====================================================================  

- Fix for caller ID value being corrupted sometimes
- Support for call confirmation in chan_woomera

* Tue Dec 18 2007 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.0.14
====================================================================  

- Fix in smg_brid not releasing some b-channels properly
- Fix in wancfg_smg not setting MTU to 80 when configuring cards for SS7

* Fri Dec 14 2007 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.0.13
====================================================================  

- Fix for Kernel panic on 64-bit systems when enabling hardware echo canceller


* Thu Dec 5 2007 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.0.11
====================================================================  

- Support for AFT Serial Cards
- Updates for AFT PMC and MAXIM framers
  PMC - lowered LOS sensitivity
        Fixes fake up/down state changes on
        started inactive lines.

  MAXIM - lowered sensistivy
          Fixes cable cross talk on 8 port cards.
        - Enabled Unframed E1
        - Enabled Tri-State Mode
        - Fixed loopback commands

- Fixed HWEC_PERSIST_DISABLE
  This option was broken in previous release
  This option lets Asterisk control HWEC
  on each call start/stop.
  By default all hwec channels are enabled on
  device startup.

- Updated SMG/SS7 
- Updated loopback commands for AFT Maxim cards

- Updated for AstLinux
  The make file can now build all WAN and Voice Protocols
  
- Fixed add_timer warnings for ALL AFT cards
  Caused when a port is left in unconnected state.

- Updated legacy protocols for new front end architecture

- Updated Setup script 



* Thu Nov 8 2007 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.0.4
====================================================================  

- Fixed A101/2 (Old) bug introduced in previous releaes

* Mon Oct 31 2007 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.0.4
====================================================================  

- Updated BRI caller name
- Updaged Setup


* Mon Oct 15 2007 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.0.1
====================================================================  

- Major Updates
- New BRI architecture/support
  SMG with Netbricks BRI Stack
- Support for Hardware DTMF


* Thu Aug 22 2007 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.0.p3
======================================================================

- Updated wancfg_zaptel to support HW DTMF


* Thu Aug 21 2007 Nenad Corbic <ncorbic@sangoma.com> - Beta - 3.3.0.p2
======================================================================  

- Major Updates
- Hardware DTMF for Asterisk and TDM API
- - END - 
